<?php
/*
Plugin Name: ERR Vids
Plugin URI: http://propxls.eu/plugins/err-vids/
Description: This plugin helps you to show Err(Eesti Rahvusringhääling) videos on your WordPress based homepage. Err(Eesti Rahvusringhääling) itself don't have embeded code version. 
Author: ProPXLS
Version: 0.1
Author URI: http://propxls.eu/
License: GPL2
License URI: https://www.gnu.org/licenses/gpl-2.0.html
Text Domain: errvids
*/

define('ERRTXTD', 'errvids');

function errvids_shortcode( $atts, $content ) {
    
    if ( !empty($atts['url']) ) {
    	
    	//Get url contents
    	$errvids_source_contents = file_get_contents($atts['url']);
    	
    	//Find err mp4 video url
    	$errvids_source_pattern = '/clip = {sources: "(.*)" };/';
		preg_match($errvids_source_pattern, $errvids_source_contents, $errvids_source_matches);
		if ( !isset($errvids_source_matches[1]) ) {
			$errvids_source_matches[1] = null;
		}
		$errvids_source_original_url = $errvids_source_matches[1];

		//Find err video still(poster)
		$errvids_still_pattern = '~\bbackground(-image)?\s*:(.*?)\(\s*(\'|")?(?<image>.*?)\3?\s*\)~i';
		preg_match($errvids_still_pattern, $errvids_source_contents, $errvids_still_matches);
		if ( !isset($errvids_still_matches['image']) ) {
			$errvids_still_matches['image'] = null;
		}
		$errvids_still_url = $errvids_still_matches['image'];



		if( !empty($errvids_source_original_url) ) {
			//Replacement in url
			$patterns = array();
			$patterns[0] = '/80/';
			$patterns[1] = '/@/';

			$replacements = array();
			$replacements[0] = '81';
			$replacements[1] = '';

			$viewUrl = preg_replace($patterns, $replacements, $errvids_source_original_url);

			$errvids_return = '<video width="704" height="auto" controls poster="'.$errvids_still_url.'"><source src="http'.$viewUrl.'" type="video/mp4">Your browser does not support the video tag.</video>';
			$errvids_return.= '<small>Video source: <a href="'.$atts['url'].'" target="_blank">'.$atts['url'].'</a></small>';
			return $errvids_return;

		} else {
			return __('Sorry, but we failed to find ERR video url. Maybe the input URL were incorrect?', ERRTXTD);
		}
    } else {
		return __('Missing URL!', ERRTXTD);
	}
}


function errvids_register_shortcode() {
    add_shortcode( 'errvid', 'errvids_shortcode' );
}
add_action( 'init', 'errvids_register_shortcode' );
